function jsMyExchange(apiID,cdiv,template)
{
	// 
	this._apiID = apiID;
	this._cdiv = cdiv;
	this._host = document.location.protocol + "//payeer.com";
	this._url = this._host+"/ajax/api/exchange.php";
	this._template = template;
	
	//     
	this.list = function()
	{
		var t=this;
		$.ajax(
		{
			type: "POST",
			url: this._url,
			data: 
			{
				"data": JSON.stringify(
						{
							cmd : "list",
							apiID : t._apiID,
							template : t._template
						})
			},
			dataType: "json",
			success: function(data)
			{
				if (data.error==0)
				{
					$(t._cdiv).html(data.result);
					t.listActions();
				}
				else
				{
					$(t._cdiv).html(data.error_msg);
				}
			},
			error: function (XMLHttpRequest, textStatus, errorThrown)
			{
				t.pre(XMLHttpRequest);
				t.pre(textStatus);
				t.pre(errorThrown);
			}
		});
	}
	
	//     
	this.listActions = function()
	{
		var t=this;
		//    
		$(this._cdiv+" .left li").mouseover(
		function()
		{
			$(t._cdiv+" .left li").removeClass("act");
			$(this).addClass("act");
			//    
			var arID=$(this).attr("id").split("_");
			$(t._cdiv+" .right li.ps_out").removeClass("forbidden");
			if ($(t._cdiv+" .right .block_"+arID[2]).hasClass("hide"))
			{
				$(t._cdiv+" .right .blocks").hide();
				$(t._cdiv+" .right .block_"+arID[2]).show();
			}
			var arExchangeForbidden = $(t._cdiv+" .left input[name=ef_"+arID[1]+"_"+arID[2]+"]").val().toString().split("|");
			for (var k in arExchangeForbidden)
			{
				$(t._cdiv+" .right li.ps_out_"+arExchangeForbidden[k]).addClass("forbidden");
			}
			//   
			var razdn = $(t._cdiv+" .left").height() - $(t._cdiv+" .right").height();
			var scrol_h = $(window).scrollTop() - 200;
			if(scrol_h > razdn)
			{
				scrol_h = razdn;
			}
			if(scrol_h < 0)
			{
				scrol_h = 0;
			}
			$(t._cdiv+" .right").stop().animate({top:scrol_h},500);
		});
		$(this._cdiv+" .left li:first").mouseover();
		//    
		$(this._cdiv+" .right li").mouseover(
		function()
		{
			$(this).addClass("act");
		}).mouseout(
		function()
		{
			$(this).removeClass("act");
		});
		// 
		$(this._cdiv+" .right li").click(
		function()
		{
			var input=$(t._cdiv+" .left li.act").attr("id");
			var output=$(t._cdiv+" .right li.act").attr("id");
			t.selectIO(input,output);
			return false;
		});
	}
	
	//  
	this.myProcessOrder = function(id_order, time_or, payed)
	{
		var t=this;		
		$.ajax(
		{
			type: "POST",
			url: t._url,
			data: 
			{
				"data": JSON.stringify(
						{
							cmd : "process_order",
							id_order : id_order,
							time_order : time_or,
							apiID : t._apiID,
							template : t._template,
							payed : payed
						})
			},
			dataType: "json",
			success: function(data)
			{
				$(t._cdiv).html(data.textblock);
				if (data.status == 4 && payed!="Y" && data.ps_go=="Y")
				{
					$(t._cdiv+" .ex_form").hide();
					
					setTimeout(function()
					{
						$(t._cdiv+" .ex_form").show("slow");
						
						$(t._cdiv+" .ex_form form.form_autosubmit").submit();	
						
						$(t._cdiv+" .ex_form input[type=submit]").click(function()
						{
							setTimeout(function()
							{
								t.myProcessOrder(id_order, time_or, 'Y');
							}, 2000);
						});											
					}, 3000);
				}
				else
				{
					//$(t._cdiv).html(data.textblock);
					if(data.status == 4 || data.status == 5)
					{
						setTimeout(function()
						{
							t.myProcessOrder(id_order, time_or, payed);
						},5000);
					}
					//     " "
					$(t._cdiv+" input[name=exchange_new]").click(function()
					{
						t.list();
						return false;
					});
				}
			}				
		});			
	}
	
	//   
	this.selectIO = function(input,output,arData)
	{
		var t=this;
		$.ajax(
		{
			type: "POST",
			url: this._url,
			data: 
			{
				"data": JSON.stringify(
						{
							cmd : "step1",
							apiID : this._apiID,
							template : t._template,
							input : input,
							output : output,
							arData : arData
						})
			},
			dataType: "json",
			success: function(data)
			{
				if (data.error==0)
				{
					$(t._cdiv).html(data.result);
					//      
					$(t._cdiv+" input.exchange_price").bind("keyup", function()
					{
						val=$(this).val();
						val=val.split(",").join(".");
						val=val.replace(/([^0-9.,]+)/,"");
						$(this).val(val);
					});
					var tm=Date.now();
					//   ""   ""
					function getBuyBySell(sum)
					{
						$.ajax(
						{
							type: "POST",
							url: t._url,
							data: 
							{
								"data": JSON.stringify(
										{
											cmd: 'balanceOutputGetPrice',
											apiID : t._apiID,
											template : t._template,
											sum: sum,
											cur: data.input[2],
											psId: data.output[1],
											psInputId: data.input[1],
											tm : tm
										})
							},
							dataType: "json",
							success: function(dlist)
							{
								if (dlist["old"]["tm"]==tm)
								{
									var sum_out = dlist['old']['list'][data.output[1]]['curr'][data.output[2]]['sum'];
									var com_sum = dlist['old']['list'][data.output[1]]['curr'][data.output[2]]['sum_com'];
									var com_curr = dlist['old']['list'][data.output[1]]['curr'][data.output[2]]['curout'];
									var discount = dlist['old']['list'][data.output[1]]['discount'];
									
									$(t._cdiv+" input[name=exchange_out]").val(sum_out);
									$(t._cdiv+" .commission .comm_ps span").html(com_sum+" "+com_curr);
									
									if (discount > 0)
									{
										$(t._cdiv+" .commission .discount span").html(discount+" %");
										$(t._cdiv+" .commission .discount").slideDown();
									}
									else
									{
										$(t._cdiv+" .commission .discount").hide();
										$(t._cdiv+" .commission .discount span").html("0%");
									}
									
								}
							}
						});
					}
					//   " "   ""
					function getSell2BySell(sum)
					{
						$.ajax(
						{
							type: "POST",
							url: t._url,
							data: 
							{
								"data": JSON.stringify(
										{
											cmd: 'balanceInputGetPrice',
											apiID : t._apiID,
											template : t._template,
											sum: sum,
											cur: data.input[2],
											psId: data.input[1],
											tm : tm
										})
							},
							dataType: "json",
							success: function(dlist)
							{
								if (dlist["old"]["tm"]==tm)
								{
									var sum_in2=dlist['old']['list'][data.input[1]]['curr'][data.input[2]]['sum'];
									$(t._cdiv+" input[name=exchange_in2]").val(sum_in2);
								}
							}
						});	
					}
					//   ""   " "
					function getSellBySell2(sum)
					{
						$.ajax(
						{
							type: "POST",
							url: t._url,
							data: 
							{
								"data": JSON.stringify(
										{
											cmd: 'balanceInputGetPrice',
											apiID : t._apiID,
											template : t._template,
											sum: sum,
											cur: data.input[2],
											breverse: 'Y',
											breverse_cur: data.input[2],
											psId: data.input[1],
											tm : tm
										})
							},
							dataType: "json",
							success: function(dlist)
							{
								if (dlist["old"]["tm"]==tm)
								{
									var sum=dlist['old']['list'][data.input[1]]['curr'][data.input[2]]['sum'];
									$(t._cdiv+" input[name=exchange_in]").val(sum);
									getBuyBySell(sum);
								}
							}
						});
					}
					//   ""   ""
					function getSellByBuy(sum)
					{
						$.ajax(
						{
							type: "POST",
							url: t._url,
							data: 
							{
								"data": JSON.stringify(
										{
											cmd: 'balanceOutputGetPrice',
											apiID : t._apiID,
											template : t._template,
											sum: sum,
											cur: data.output[2],
											breverse_cur: data.input[2],
											breverse: 'Y',
											psId: data.output[1],
											psInputId: data.input[1],
											tm : tm
										})
							},
							dataType: "json",
							success: function(dlist)
							{
								if (dlist["old"]["tm"]==tm)
								{
									var sum=dlist['old']['list'][data.output[1]]['curr'][data.output[2]]['sum'];
									$(t._cdiv+" input[name=exchange_in]").val(sum);
									getSell2BySell(sum);
									var discount = dlist['old']['list'][data.output[1]]['discount'];
									
									var com_sum = dlist['old']['list'][data.output[1]]['curr'][data.output[2]]['sum_com'];
									var com_curr = dlist['old']['list'][data.output[1]]['curr'][data.output[2]]['curout'];
									$(t._cdiv+" .commission .comm_ps span").html(com_sum+" "+com_curr);
									
									if (discount > 0)
									{
										$(t._cdiv+" .commission .discount span").html(discount+" %");
										$(t._cdiv+" .commission .discount").slideDown();
									}
									else
									{
										$(t._cdiv+" .commission .discount").hide();
										$(t._cdiv+" .commission .discount span").html("0%");
									}
								}
							}
						});
					}
					//    input'
					$(t._cdiv+" input[name=exchange_in]").keyup(function()
					{
						tm=Date.now();
						var sum = $(this).val();
						getBuyBySell(sum);
						getSell2BySell(sum);								
					});					
					$(t._cdiv+" input[name=exchange_in2]").keyup(function()
					{
						tm=Date.now();
						getSellBySell2($(this).val());
					});					
					$(t._cdiv+" input[name=exchange_out]").keyup(function()
					{
						tm=Date.now();
						getSellByBuy($(this).val());													
					});
					
					//  ,     (  )   
					var min_type=$(t._cdiv+" input[name=exchange_min_type]").val();
					var min_sum=$(t._cdiv+" input[name=exchange_min_sum]").val();

					switch (min_type)
					{
						case "INPUT":
							if ($(t._cdiv+" input[name=exchange_in]").val()=="")
							{
								$(t._cdiv+" input[name=exchange_in]").val(min_sum).keyup();
							}
						break;
						
						case "OUTPUT":
							if ($(t._cdiv+" input[name=exchange_out]").val()=="")
							{
								$(t._cdiv+" input[name=exchange_out]").val(min_sum).keyup();
							}
						break;
					}
					
					//  
					$(t._cdiv+" input[name=send]").click(function()
					{
						t.dataSend(t.serialize(t._cdiv+" .c_form_exchange"));		
						return false;				
					});
					
				}
				else
				{
					$(t._cdiv).html(data.error_msg);
				}
			}
		});		
	}
	
	//    
	this.dataSend = function(form_data)
	{
		var t=this;
		
		//    
		$(t._cdiv+" input").attr("disabled", true);
		$(t._cdiv+" input.error").removeClass("error");
		$(t._cdiv+" span.desc").removeClass("error");
		$(t._cdiv+" span.error").empty();
		$(t._cdiv+" .other_error").empty().hide();
		
		$.ajax(
		{
			type: "POST",
			url: t._url,
			data: 
			{
				"data": JSON.stringify(
						{
							cmd: 'step2',
							apiID : t._apiID,
							template : t._template,
							form : form_data
						})
			},
			dataType: "json",
			success: function(data)
			{
				$(t._cdiv+" input").attr("disabled", false);
				if (data.error==0)
				{
					if (data.form_error==0)
					{
						$(t._cdiv).html(data.result);
						
						//   
						$(t._cdiv+" input[name=send]").click(function()
						{
							t.confirmDataSend(t.serialize(t._cdiv+" .c_form_exchange"));
							return false;			
						});
						
						//   
						$(t._cdiv+" input[name=cancel]").click(function()
						{
							t.selectIO("sell_"+form_data.exchange_ps_in+"_"+form_data.exchange_cur_in,"buy_"+form_data.exchange_ps_out+"_"+form_data.exchange_cur_out,form_data);
							return false;			
						});
						
						//  
						$(t._cdiv+" #id_captcha_img").click(function()
						{
							t.captchaReload();		
							return false;				
						});
					}
					else
					{
						for (var key in data.arFormError) 
						{
							var val = data.arFormError[key];
							if((!$(t._cdiv+" ."+key+" span.error").length) && (!$(t._cdiv+" ."+key+" span.desc").length))
							{
								$(t._cdiv+" .other_error").show().append(val+'<br/>');
							}	
							else
							{
								$(t._cdiv+" ."+key+" input").addClass("error");
								$(t._cdiv+" ."+key+" span.error").html(val);
								$(t._cdiv+" ."+key+" span.desc").addClass("error");
							}
						}
					}
				}
				else
				{
					$(t._cdiv).html(data.error_msg);
				}
			}
		});
	}
	
	//   
	this.confirmDataSend = function(form_data)
	{
		var t=this;
		
		//    
		$(t._cdiv+" input").attr("disabled", true);
		$(t._cdiv+" input.error").removeClass("error");
		$(t._cdiv+" span.desc").removeClass("error");
		$(t._cdiv+" span.error").empty();
		$(t._cdiv+" .other_error").empty().hide();
		
		$.ajax(
		{
			type: "POST",
			url: t._url,
			data: 
			{
				"data": JSON.stringify(
						{
							cmd: 'step3',
							apiID : t._apiID,
							template : t._template,
							form : form_data
						})
			},
			dataType: "json",
			success: function(data)
			{
				$(t._cdiv+" input").attr("disabled", false);
				if (data.error==0)
				{
					if (data.form_error==0)
					{
						t.myProcessOrder(data.order_id,data.order_date);
					}
					else
					{
						for (var key in data.arFormError) 
						{
							var val = data.arFormError[key];
							if((!$(t._cdiv+" ."+key+" span.error").length) && (!$(t._cdiv+" ."+key+" span.desc").length))
							{
								$(t._cdiv+" .other_error").show().append(val+'<br/>');
							}	
							else
							{
								$(t._cdiv+" ."+key+" input").addClass("error");
								$(t._cdiv+" ."+key+" span.error").html(val);
								$(t._cdiv+" ."+key+" span.desc").addClass("error");
							}
						}
						$(t._cdiv+" input[name=exchange_captcha_sid]").val(data.sid);
						$(t._cdiv+" #id_captcha_img").attr("src",data.img);
						$(t._cdiv+" #id_exchange_captcha").val("");
					}
				}
				else
				{
					$(t._cdiv).html(data.error_msg);
				}
			}
		});
	}

	this.captchaReload = function()
	{
		var t=this;
		$.ajax(
		{
			type: "POST",
			url: t._url,
			data: 
			{
				"data": JSON.stringify(
						{
							cmd: 'captchaReload',
							apiID : t._apiID,
							template : t._template
						})
			},
			dataType: "json",
			success: function(data)
			{
				$(t._cdiv+" input[name=exchange_captcha_sid]").val(data.sid);
				$(t._cdiv+" #id_captcha_img").attr("src",data.img);
			}
		});		
	}
	
	this.serialize = function(e)
	{
		var ob=$(e).serializeArray();
		var result=new Object;
		for (var key in ob) 
		{
			var val = ob[key];
			result[val.name]=val.value;
		}
		return result;
	}
	
	this.pre = function(e)
	{
		console.log(e);
	}
}